# IMPORT STATEMENTS
import cv2
import re
import numpy as np
import matplotlib
matplotlib.use("pdf")
from matplotlib import pyplot as plt
from mpl_toolkits.axes_grid1 import make_axes_locatable, axes_size
import matplotlib.patches as patches
import matplotlib.colors as colors
import PIL
import math
#get_ipython().run_line_magic('matplotlib', 'inline')
import pandas as pd
import seaborn as sns
import json
from pprint import pprint
import os
import pickle
import sys
sys.path.append("/booleanfs/sahoo/scripts/")
sys.path.append("/booleanfs2/sahoo/Hegemon/")
import StepMinerNew as smn
import HegemonUtil as hu
acolor = ["#00CC00", "#D8A03D","#EC008C",
        'cyan', "#B741DC", "#808285",
        'blue', 'black', 'green', 'red']

plt.rc('text', usetex=True)

import bone
reload(bone)
reload(hu)
from matplotlib_venn import venn2

def T1():
    fig, axes = plt.subplots(nrows=1, ncols=2, figsize=(10,12))

    thr = 0.1
    ifile = "figures/ravi-diff.txt"
    bone.printStats(ifile, thr)
    high, low = bone.getFdrStats(ifile, thr, 1)
    high = set(high).difference(set(["---"]))
    low = set(low).difference(set(["---"]))
    print len(high), len(low)
    bone.saveList("figures/ravi-up.txt", high)
    bone.saveList("figures/ravi-down.txt", low)

    thr = 0.15
    ifile = "figures/sailaja-diff.txt"
    #ifile = "figures/aldiri-hs-diff.txt"
    #file = "figures/hudson-diff.txt"
    bone.printStats(ifile, thr)
    hi, lo = bone.getFdrStats(ifile, thr, 1)
    hi = set(hi).difference(set(["---"]))
    lo = set(lo).difference(set(["---"]))
    print len(hi), len(lo)
    bone.saveList("figures/sailaja-up.txt", hi)
    bone.saveList("figures/sailaja-down.txt", lo)

    venn2([high, hi], set_labels=("Ravi", "GSE125903"), ax=axes[0])
    venn2([low, lo], set_labels=("Ravi", "GSE125903"), ax=axes[1])

    fig.savefig("figures/rt-vs-rb-comp-1.pdf", dpi=100)

def getNameHash(cfile):
    if not os.path.isfile(cfile):
        print "Can't open file {0} <br>".format(cfile);
        exit()
    fp = open(cfile, "r")
    res = {}
    for line in fp:
        line = line.strip();
        ll = re.split("[\t]", line);
        res[ll[0]] = ll[2]
    fp.close();
    return res

def getSet(cfile, i1, i2):
    nhash = getNameHash("figures/human-gpl570-select.txt")
    if not os.path.isfile(cfile):
        print "Can't open file {0} <br>".format(cfile);
        exit()
    fp = open(cfile, "r")
    res = {}
    for line in fp:
        line = line.strip();
        ll = re.split("[\t]", line);
        if ll[0] not in nhash or ll[1] not in nhash:
            continue
        k = nhash[ll[i1 - 2]]
        if k not in res:
            res[k] = []
        res[k] += [nhash[ll[i2 - 2]]]
    fp.close();
    return res


def getSet1(cfile, i1, i2):
    if not os.path.isfile(cfile):
        print "Can't open file {0} <br>".format(cfile);
        exit()
    fp = open(cfile, "r")
    res = {}
    for line in fp:
        line = line.strip();
        ll = re.split("[\t]", line);
        n = re.split(" /// ", ll[i1]);
        for k in n:
            if k not in res:
                res[k] = []
            res[k] += [ll[i2]]
    fp.close();
    return res

def getHash(cfile):
    nhash = getNameHash("figures/human-gpl570-select.txt")
    if not os.path.isfile(cfile):
        print "Can't open file {0} <br>".format(cfile);
        exit()
    fp = open(cfile, "r")
    res = {}
    for line in fp:
        line = line.strip();
        ll = re.split("[\t]", line);
        if ll[0] not in nhash or ll[1] not in nhash:
            continue
        k = nhash[ll[0]]
        if k not in res:
            res[k] = []
        res[k] += [nhash[ll[1]]]
        k = nhash[ll[1]]
        if k not in res:
            res[k] = []
        res[k] += [nhash[ll[0]]]
    fp.close();
    return res

def T2():
    n1 = 2
    def check1(k, res1, res2, res3):
	return k in res3
	#return k in res2 and k in res3 and len(res1[k]) > n1 * len(res2[k])
	
    res1 = getSet("figures/ravi-hilo-2.txt", 2, 3)
    res2 = getSet("figures/ravi-hihi-1.txt", 2, 3)
    res3 = getHash("figures/ravi-hihi-2.txt")
    #high = set([k for k in res1 if k in res2 and k in res3 and len(res1[k]) > n1 * len(res2[k])])
    high = set([k for k in res1 if check1(k, res1, res2, res3)])

    res1 = getSet("figures/ravi-hilo-2.txt", 3, 2)
    res2 = getSet("figures/ravi-hihi-1.txt", 3, 2)
    #low = set([k for k in res1 if k in res2 and k in res3 and len(res1[k]) > n1 * len(res2[k])])
    low = set([k for k in res1 if check1(k, res1, res2, res3)])

    res1 = getSet("figures/sailaja-hilo-2.txt", 2, 3)
    res2 = getSet("figures/sailaja-hihi-1.txt", 2, 3)
    res3 = getHash("figures/sailaja-hihi-2.txt")
    #hi = set([k for k in res1 if k in res2 and k in res3 and len(res1[k]) > n1 * len(res2[k])])
    hi = set([k for k in res1 if check1(k, res1, res2, res3)])

    res1 = getSet("figures/sailaja-hilo-2.txt", 3, 2)
    res2 = getSet("figures/sailaja-hihi-1.txt", 3, 2)
    #lo = set([k for k in res1 if k in res2 and k in res3 and len(res1[k]) > n1 * len(res2[k])])
    lo = set([k for k in res1 if check1(k, res1, res2, res3)])

    fig, axes = plt.subplots(nrows=1, ncols=2, figsize=(10,12))
    venn2([high, hi], set_labels=("Ravi", "GSE125903"), ax=axes[0])
    venn2([low, lo], set_labels=("Ravi", "GSE125903"), ax=axes[1])

    fig.savefig("figures/rt-vs-rb-comp-2.pdf", dpi=100)

def T3():
    import bone
    reload(bone)
    import datetime
    from matplotlib.backends.backend_pdf import PdfPages
    pdf = PdfPages('figures/rt-vs-rb-comp-3.pdf')

    def processGroup(l1, wt1):
	ana = bone.RBAnalysis()
	ana.getRavi2017()
	fig = bone.processOneDataset(ana, l1, wt1)
	pdf.savefig(fig)

	ana = bone.RBAnalysis()
	ana.getSailaja2019()
	fig = bone.processOneDataset(ana, l1, wt1)
	pdf.savefig(fig)

	ana = bone.RBAnalysis()
	ana.getSailaja2020(3)
	fig = bone.processOneDataset(ana, l1, wt1)
	pdf.savefig(fig)

	ana = bone.RBAnalysis()
	ana.getKooi2015(2)
	fig = bone.processOneDataset(ana, l1, wt1)
	pdf.savefig(fig)

	ana = bone.RBAnalysis()
	ana.getMcEvoy2011()
	fig = bone.processOneDataset(ana, l1, wt1)
	pdf.savefig(fig)

	ana = bone.RBAnalysis()
	ana.getAldiri2017(2)
	fig = bone.processOneDataset(ana, l1, wt1)
	pdf.savefig(fig)

	ana = bone.RBAnalysis()
	ana.getHudson2018(2)
	fig = bone.processOneDataset(ana, l1, wt1)
	pdf.savefig(fig)

	ana = bone.RBAnalysis()
	ana.getHudson2018(3)
	fig = bone.processOneDataset(ana, l1, wt1)
	pdf.savefig(fig)

	ana = bone.RBAnalysis()
	ana.getHudson2018(4)
	fig = bone.processOneDataset(ana, l1, wt1)
	pdf.savefig(fig)

	ana = bone.RBAnalysis()
	ana.getHudson2018(5)
	fig = bone.processOneDataset(ana, l1, wt1)
	pdf.savefig(fig)

	ana = bone.RBAnalysis()
	ana.getKooi2016()
	fig = bone.processOneDataset(ana, l1, wt1)
	pdf.savefig(fig)

	ana = bone.RBAnalysis()
	ana.getVenkatesan2012()
	fig = bone.processOneDataset(ana, l1, wt1)
	pdf.savefig(fig)

	ana = bone.RBAnalysis()
	ana.getMcEvoy2011Mm(3)
	fig = bone.processOneDataset(ana, l1, wt1, None, 'Mm')
	pdf.savefig(fig)

	ana = bone.RBAnalysis()
	ana.getAldiri2015(2)
	fig = bone.processOneDataset(ana, l1, wt1, None, 'Mm')
	pdf.savefig(fig)

	ana = bone.RBAnalysis()
	ana.getAldiri2015(3)
	fig = bone.processOneDataset(ana, l1, wt1, None, 'Mm')
	pdf.savefig(fig)

    low = set(bone.getEntries("figures/r-s-c-down.txt", 0))
    high = set(bone.getEntries("figures/r-s-c-up.txt", 0))
    l1 = [ high, low]
    wt1 = [-1, 1]
    genes = []
    processGroup(l1, wt1)

    l1, wt1 = getMcEvoySignature()
    processGroup(l1, wt1)


    d = pdf.infodict()
    d['Title'] = 'Prediction diffferentiation state'
    d['Author'] = 'Debashis Sahoo'
    d['Subject'] = 'Retina retinoblastoma'
    d['Keywords'] = 'disease training validation ROC retina'
    d['CreationDate'] = datetime.datetime(2020, 1, 16)
    d['ModDate'] = datetime.datetime.today()
    pdf.close()

def processOne(ana, l1, wt1, desc, ax = None, sp = 'Hs'):
    if sp == 'Hs':
        ana.orderData(l1, wt1)
    else:
        genes = []
        ana.convertMm(l1, genes)
        ana.orderData(ana.gene_groups, wt1)
    params = {'spaceAnn': len(ana.order)/len(ana.atypes),
            'tAnn': 1, 'widthAnn':1, 'acolor': acolor,
            'w': 5, 'h': 0.8, 'atypes': ana.atypes ,'cval': ana.cval,
            'ax': ax}
    ax = ana.printTitleBar(params)
    res = ana.getMetrics2(ana.cval[0])
    ax.text(len(ana.cval[0]), 4, ",".join(res))
    ax.text(-1, 2, desc, horizontalalignment='right',
            verticalalignment='center')
    return ax

def getMcEvoySignature():
    cfile = "/booleanfs2/sahoo/Data/RB/database/cell-type-signature.txt"
    if not os.path.isfile(cfile):
	print "Can't open file {0} <br>".format(cfile);
	exit()
    fp = open(cfile, "r")
    ahash = {}
    bhash = {}
    head = fp.readline()
    head = fp.readline()
    head = fp.readline()
    for line in fp:
	line = line.strip();
	ll = re.split("[\t]", line);
	if ll[0] not in ahash:
	    ahash[ll[0]] = []
	if ll[0] not in bhash:
	    bhash[ll[0]] = []
	for k in ll[1].split(' /// '):
	    ahash[ll[0]].append(k)
	for k in ll[3].split(' /// '):
	    bhash[ll[0]].append(k)
    fp.close();
    for k in ahash:
	print k, len(ahash[k]), len(bhash[k])
    keys = ['G2_M', 'progenitor', 'amacrine', 'ganglion', 'cone',  'rod', 'Muller']
    l1 = [set(ahash[k]) for k in keys]
    wt1 = [1, 1, -1, -1, -1, -1, -1]
    return l1, wt1

def T4():
    import bone
    reload(bone)
    import datetime
    from matplotlib.backends.backend_pdf import PdfPages
    pdf = PdfPages('figures/rt-vs-rb-comp-4.pdf')

    def processGroup(l1, wt1):
	fig, axes = plt.subplots(nrows=23, ncols=1, figsize=(5,18))

	ana = bone.RBAnalysis()
	ana.getRavi2017()
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[0])

	ana = bone.RBAnalysis()
	ana.getSailaja2019()
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[1])

	ana = bone.RBAnalysis()
	ana.getSailaja2020(3)
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[2])

	ana = bone.RBAnalysis()
	ana.getKooi2015(2)
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[3])

	ana = bone.RBAnalysis()
	ana.getKooi2015(3)
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[4])

	ana = bone.RBAnalysis()
	ana.getKooi2015(4)
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[5])

	ana = bone.RBAnalysis()
	ana.getGratias2007()
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[6])

	ana = bone.RBAnalysis()
	ana.getMcEvoy2011()
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[7])

	ana = bone.RBAnalysis()
	ana.getAldiri2017(2)
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[8])

	ana = bone.RBAnalysis()
	ana.getHudson2018(2)
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[9])

	ana = bone.RBAnalysis()
	ana.getHudson2018(3)
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[10])

	ana = bone.RBAnalysis()
	ana.getHudson2018(4)
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[11])

	ana = bone.RBAnalysis()
	ana.getHudson2018(5)
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[12])

	ana = bone.RBAnalysis()
	ana.getHudson2018(6)
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[13])

	ana = bone.RBAnalysis()
	ana.getKooi2016()
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[14])

	ana = bone.RBAnalysis()
	ana.getVenkatesan2012()
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[15])

	ana = bone.RBAnalysis()
	ana.getNalini2013()
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[16])

	ana = bone.RBAnalysis()
	ana.getNalini2013(3)
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[17])

	ana = bone.RBAnalysis()
	ana.getMcEvoy2011Mm(3)
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[18], 'Mm')

	ana = bone.RBAnalysis()
	ana.getAldiri2015(2)
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[19], 'Mm')

	ana = bone.RBAnalysis()
	ana.getAldiri2015(3)
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[20], 'Mm')

	ana = bone.RBAnalysis()
	ana.getMcCurdy2017()
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[21], 'Mm')

	ana = bone.RBAnalysis()
	ana.getMcCurdy2017(3)
	ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[22], 'Mm')

	pdf.savefig(fig)

    low = set(bone.getEntries("figures/r-s-c-down.txt", 0))
    high = set(bone.getEntries("figures/r-s-c-up.txt", 0))
    l1 = [ high, low]
    wt1 = [-1, 1]
    genes = []
    processGroup(l1, wt1)

    l1 = [ high, low]
    wt1 = [0, 1]
    processGroup(l1, wt1)

    l1, wt1 = getMcEvoySignature()
    processGroup(l1, wt1)

    processGroup([l1[0]], [1])

    l1 = [ ["E2F1", "E2F2", "E2F3", "PCNA", "CCNE1"], 
            ["RHO", "CNGB1", "ROM1", "PDE6G", "CNGA1"], 
            ["PDE6C", "PDE6H", "GNAT2", "OPN1SW", "ARR3"]]
    wt1 = [1, -1, -1]
    processGroup(l1, wt1)

    d = pdf.infodict()
    d['Title'] = 'Prediction diffferentiation state'
    d['Author'] = 'Debashis Sahoo'
    d['Subject'] = 'Retina retinoblastoma'
    d['Keywords'] = 'disease training validation ROC retina'
    d['CreationDate'] = datetime.datetime(2020, 1, 16)
    d['ModDate'] = datetime.datetime.today()
    pdf.close()

def getEntries(cfile, index):
    if not os.path.isfile(cfile):
        print "Can't open file {0} <br>".format(cfile);
        exit()
    fp = open(cfile, "r")
    res = []
    for line in fp:
        line = line.strip();
        ll = re.split("[\t]", line);
        if index < len(ll) and ll[index] != "":
            res += [ll[index]]
    fp.close();
    return res


def getCao21():
    cfile = "data/peerj-8873-Supplementary_Table_1_Retinoblastoma_progression_signatures.txt"
    l1 = getEntries(cfile, 2)[1:]
    df = pd.read_csv("figures/ravi-diff.txt", sep="\t", header=None,
                    names=['ArrayID', 'Name', 'T', 'p', 'diff'])
    idx = df[df['Name'].isin(l1)].groupby('Name')['p'].idxmin
    df1 = df.iloc[idx]
    l1 = [list(df1[df1['T'] > 0]['Name']), list(df1[df1['T'] < 0]['Name'])]
    wt1 = [-1, 1]
    return l1, wt1

def getCaoSubtypes():
    cfile = "data/peerj-8873-Supplementary_Table_2_RB_subtype_specific_genes.txt"
    l1 = getEntries(cfile, 0)[2:]
    l2 = getEntries(cfile, 1)[1:]
    l3 = getEntries(cfile, 2)[1:]
    l4 = getEntries(cfile, 3)[1:]
    return [l1, l2, l3, l4]

def T5():
    import bone
    reload(bone)
    import datetime
    from matplotlib.backends.backend_pdf import PdfPages
    pdf = PdfPages('figures/rt-vs-rb-comp-5.pdf')

    def processGroup(ana, sp = 'Hs'):
	keys = ['G2/M', 'progenitor', 'amacrine', 'ganglion', 'cone',  'rod', 'Muller']
    	l1, wt1 = getMcEvoySignature()
        n = len(keys) + 1
	fig, axes = plt.subplots(nrows=n, ncols=1, figsize=(5,5))
        res = []
        ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[0], sp)
        roc = ana.getMetrics()
        src = ana.h.getSource()
        gsrc = "GSE29686"
        res.append(["McEvoy", roc, gsrc, src, np.sum([len(k) for k in l1])])

        for i in range(2):
	    ax = processOne(ana, [l1[i]], [1], keys[i], axes[i + 1], sp)
            roc = ana.getMetrics()
            res.append(["McEvoy/" + keys[i], roc, gsrc, src, len(l1[i])])
	for i in range(2, len(keys)):
	    ax = processOne(ana, [l1[i]], [-1], keys[i], axes[i + 1], sp)
            roc = ana.getMetrics()
            res.append(["McEvoy/" + keys[i], roc, gsrc, src, len(l1[i])])
	pdf.savefig(fig)
        return res

    def processGroup2(ana, sp = 'Hs'):
        keys = ["amacrine", "ganglion", "Mullernorm", "rod",
                "bipolar", "cone", "Mullerinjure", "Mullerregene", "stress"]
        n = len(keys) + 7
        res = []

	fig, axes = plt.subplots(nrows=n, ncols=1, figsize=(5,12))

        low = set(bone.getEntries("figures/r-s-c-down.txt", 0))
        high = set(bone.getEntries("figures/r-s-c-up.txt", 0))
        l1 = [ high, low]
        wt1 = [-1, 1]
        ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[0], sp)
        roc = ana.getMetrics()
        src = ana.h.getSource()
        gsrc = "Boolean"
        res.append(["Boolean", roc, gsrc, src, np.sum([len(k) for k in l1])])

        l1 = [ high, low]
        wt1 = [0, 1]
        ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[1], sp)
        roc = ana.getMetrics()
        res.append(["Boolean/Up", roc, gsrc, src, len(low)])

        l1 = [ high, low]
        wt1 = [-1, 0]
        ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[2], sp)
        roc = ana.getMetrics()
        res.append(["Boolean/Down", roc, gsrc, src, len(high)])

        l1 = [ ["E2F1", "E2F2", "E2F3", "PCNA", "CCNE1"], 
                ["RHO", "CNGB1", "ROM1", "PDE6G", "CNGA1"], 
                ["PDE6C", "PDE6H", "GNAT2", "OPN1SW", "ARR3"]]
        wt1 = [1, -1, -1]
        ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[3], sp)
        roc = ana.getMetrics()
        gsrc = "GSE59983"
        res.append(["Kooi", roc, gsrc, src, np.sum([len(k) for k in l1])])

        wt1 = [1, 0, 0]
        ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[4], sp)
        roc = ana.getMetrics()
        res.append(["Kooi/Up", roc, gsrc, src, len(l1[0])])

        wt1 = [0, -1, -1]
        ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[5], sp)
        roc = ana.getMetrics()
        res.append(["Kooi/Down", roc, gsrc, src, len(l1[1]) + len(l1[2])])

        dir1 = "/booleanfs2/sahoo/Data/RB/database/"
        l1 = [set(bone.getEntries(dir1 + k + ".txt", 21)[1:]) for k in keys]
        wt1 = [-1, -1, -1, -1, -1, -1, -1, -1, -1]
        if (sp == 'Hs'):
            l1 = bone.getGroupsHs(l1)
        ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[6], 'Hs')
        roc = ana.getMetrics()
        gsrc = "GSE74181"
        res.append(["Aldiri", roc, gsrc, src, np.sum([len(k) for k in l1])])

	for i in range(len(keys)):
	    ax = processOne(ana, [l1[i]], [-1], keys[i], axes[i + 7], 'Hs')
            roc = ana.getMetrics()
            res.append(["Aldiri/" + keys[i], roc, gsrc, src, len(l1[i])])
	pdf.savefig(fig)
        return res

    def processGroup3(ana, sp = 'Hs'):
        res = []
	fig, axes = plt.subplots(nrows=6, ncols=1, figsize=(5,12))

        l1 = [["CLUL1", "CNGB1", "ROM1", "LRRC39", "RDH12"]]
        wt1 = [-1]
        ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[0], sp)
        roc = ana.getMetrics()
        src = ana.h.getSource()
        gsrc = "PMID: 32509443"
        res.append(["Cao/5", roc, gsrc, src, np.sum([len(k) for k in l1])])

        l1, wt1 = getCao21()
        ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[1], sp)
        roc = ana.getMetrics()
        res.append(["Cao/21", roc, gsrc, src, np.sum([len(k) for k in l1])])

        st1 = getCaoSubtypes()
        l1 = [st1[0]]
        wt1 = [1]
        ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[2], sp)
        roc = ana.getMetrics()
        res.append(["Cao/subtype1", roc, gsrc, src, np.sum([len(k) for k in l1])])

        l1 = [st1[1]]
        wt1 = [1]
        ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[3], sp)
        roc = ana.getMetrics()
        res.append(["Cao/subtype2", roc, gsrc, src, np.sum([len(k) for k in l1])])

        l1 = [st1[2]]
        wt1 = [1]
        ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[4], sp)
        roc = ana.getMetrics()
        res.append(["Cao/subtype3", roc, gsrc, src, np.sum([len(k) for k in l1])])

        l1 = [st1[3]]
        wt1 = [1]
        ax = processOne(ana, l1, wt1, ana.h.getTitle(), axes[5], sp)
        roc = ana.getMetrics()
        res.append(["Cao/subtype4", roc, gsrc, src, np.sum([len(k) for k in l1])])

	pdf.savefig(fig)
        return res


    ana = bone.RBAnalysis()
    ana.getAldiri2017(2)
    res1 = processGroup(ana)
    res1 += processGroup2(ana)
    res1 += processGroup3(ana)

    ana = bone.RBAnalysis()
    ana.getNalini2013(3)
    res2 = processGroup(ana)
    res2 += processGroup2(ana)
    res2 += processGroup3(ana)

    ana = bone.RBAnalysis()
    ana.getMcEvoy2011Mm(3)
    res3 = processGroup(ana, 'Mm')
    res3 += processGroup2(ana, 'Mm')
    res3 += processGroup3(ana, 'Mm')

    ana = bone.RBAnalysis()
    ana.getMcCurdy2017(3)
    res4 = processGroup(ana, 'Mm')
    res4 += processGroup2(ana, 'Mm')
    res4 += processGroup3(ana, 'Mm')

    arr = [res1, res2, res3, res4]
    print "\t".join(["Name", "ROC", "GSEID"] + [k[0][3] for k in arr])
    for i in range(len(res1)):
        g = [res1[i][0], np.mean([float(k[i][1]) for k in arr])] + \
                [res1[i][2]] + [k[i][1] for k in arr]
        print "\t".join([ str(k) for k in g ])

    d = pdf.infodict()
    d['Title'] = 'Prediction diffferentiation state'
    d['Author'] = 'Debashis Sahoo'
    d['Subject'] = 'Retina retinoblastoma'
    d['Keywords'] = 'disease training validation ROC retina'
    d['CreationDate'] = datetime.datetime(2020, 1, 16)
    d['ModDate'] = datetime.datetime.today()
    pdf.close()

def T6():
    df = pd.read_table("figures/res-2.txt")
    df = df.iloc[::-1]
    ax = df.plot.barh(x='Name', y='ROC', color='orange', figsize=(2, 5))
    ax.set_xlim([0.3, 1.0])
    ax.set_xlabel("RT vs RB")
    ax.set_ylabel("")
    ax.get_figure().savefig("figures/rt-vs-rb-comp-6.pdf", dpi=100)

def T7():
    df = pd.read_csv("figures/diff-1.txt")
    df1 = df.rename(columns={df.columns[0]: "GID"})
    df = pd.read_csv("figures/diff-2.txt")
    df2 = df.rename(columns={df.columns[0]: "GID"})
    df = pd.read_csv("figures/diff-3.txt")
    df3 = df.rename(columns={df.columns[0]: "GID"})
    idlist = bone.getEntries("figures/diff-rt-ncc.txt", 0)
    idhash = {}
    for i in range(len(idlist)):
	idhash[idlist[i]] = i
    p1 = bone.getEntries("figures/diff-rt-cl.txt", 3)
    p2 = bone.getEntries("figures/diff-rt-ncc.txt", 3)
    p3 = bone.getEntries("figures/diff-cl-ncc.txt", 3)
    d1 = bone.getEntries("figures/diff-rt-cl.txt", 4)
    d2 = bone.getEntries("figures/diff-rt-ncc.txt", 4)
    d3 = bone.getEntries("figures/diff-cl-ncc.txt", 4)
    s1 = [re.sub("\\..*", "", k) for k in set(df1['GID'])]
    s2 = [re.sub("\\..*", "", k) for k in set(df2[df2['padj'] < 0.005]['GID'])]
    s3 = [re.sub("\\..*", "", k) for k in set(df3[df3['padj'] < 0.005]['GID'])]
    #s1 = [k for k in s1 if float(p1[idhash[k]]) < 0.001]
    s2 = [k for k in s2 if float(p2[idhash[k]]) < 0.006 and abs(float(d2[idhash[k]])) > 1.8 and
	 float(p1[idhash[k]]) > 0.001]
    s3 = [k for k in s3 if float(p3[idhash[k]]) < 0.006 and abs(float(d3[idhash[k]])) > 1.8 and
	 float(p1[idhash[k]]) > 0.001]
    print len(s1), len(s2), len(s3)
    s4 = set(s2).intersection(s3).intersection(s1)
    print len(s4)
    print len(set(s1).difference(set(s2).union(s3)))
    print len(set(s2).difference(set(s1).union(s3)))
    print len(set(s3).difference(set(s2).union(s1)))
    print len(set(s1).intersection(s2).difference(s4))
    print len(set(s2).intersection(s3).difference(s4))
    print len(set(s1).intersection(s3).difference(s4))
    s5 = set(s2).intersection(s3).difference(s1)
    print len(s5)
    from matplotlib_venn import venn3
    v = venn3(subsets = (len(set(s1).difference(set(s2).union(s3))),
		     len(set(s2).difference(set(s1).union(s3))),
		     len(set(s1).intersection(s2).difference(s3)),
		     len(set(s3).difference(set(s2).union(s1))),
		     len(set(s1).intersection(s3).difference(s2)),
		     len(set(s2).intersection(s3).difference(s1)),
		     len(set(s2).intersection(s3).intersection(s1))),
	  set_labels = ('Retina vs Y79/Weri', 'Retina vs NCC', 'Y79/Weri vs NCC'),
	  alpha = 0.5)
    plt.gca().get_figure().savefig("figures/rt-vs-rb-comp-7.pdf", dpi=100)
    ana = bone.RBAnalysis()
    ana.getSailaja2020(4)
    s6 = [ana.h.getSimpleName(k) for k in s5]
    df = bone.reactome(" ".join(s6))
    df.to_csv("figures/reactome-1.txt", sep="\t")

def getVolcano(ana, cfile, genes):
    h = ana.h
    list1 = []
    for g in genes:
        id1 = h.getBestID(h.getIDs(g).keys())
        if id1 is None:
            print g
            continue
        list1 += [id1]
    idlist = bone.getEntries(cfile, 0)
    idhash = {}
    for i in range(len(idlist)):
        idhash[idlist[i]] = i
    order = [idhash[k] for k in list1]
    pval = [float(i) for i in bone.getEntries(cfile, 3)]
    fc = [float(i) for i in bone.getEntries(cfile, 4)]
    c = ["black" for i in fc]
    df = pd.DataFrame()
    df["-log10(p)"] = -np.log10(pval)
    df["log(FC)"] = fc
    for i in range(len(pval)):
        if df["-log10(p)"][i] >= -np.log10(0.05) and abs(df["log(FC)"][i]) >= 1:
            c[i] = "green"
        if df["-log10(p)"][i] >= -np.log10(0.05) and abs(df["log(FC)"][i]) < 1:
            c[i] = "red"
        if df["-log10(p)"][i] < -np.log10(0.05) and abs(df["log(FC)"][i]) >= 1:
            c[i] = "orange"
    df["color"] = c
    df.dropna(inplace = True)
    ax = df.plot.scatter("log(FC)", "-log10(p)", c = df["color"],
            s=8, alpha=0.2, figsize=(6, 4))
    ax.set_xlim([-9, 9])
    ax.set_ylim([0, 9])
    for i in order:
        ax.text(fc[i], -np.log10(pval[i]),  h.getSimpleName(idlist[i]),
                    horizontalalignment='left', verticalalignment='top')
        ax.plot([fc[i]], [-np.log10(pval[i])], "bo", ms=4)

def T8():
    import bone
    reload(bone)
    import datetime
    from matplotlib.backends.backend_pdf import PdfPages
    pdf = PdfPages('figures/rt-vs-rb-comp-8.pdf')

    genes = ["GABRA1", "OPCML", "B3GAT1", "RIBC1", "FRMPD4",
             "MYBL2", "FAM72A", "CKAP2L", "UBE2C", "DEPDC1B"]
    ana = bone.RBAnalysis()
    ana.getSailaja2019(2)
    getVolcano(ana, "figures/sailaja-diff.txt", genes)
    pdf.savefig()

    genes = ["GABRA1", "OPCML", "B3GAT1", "RIBC1", "FRMPD4",
             "MYBL2", "FAM72A", "CKAP2L", "UBE2C", "DEPDC1B"]
    ana = bone.RBAnalysis()
    ana.getRavi2017()
    getVolcano(ana, "figures/ravi-diff.txt", genes)
    pdf.savefig()

    d = pdf.infodict()
    d['Title'] = 'Prediction diffferentiation state'
    d['Author'] = 'Debashis Sahoo'
    d['Subject'] = 'Retina retinoblastoma'
    d['Keywords'] = 'disease training validation ROC retina'
    d['CreationDate'] = datetime.datetime(2020, 1, 16)
    d['ModDate'] = datetime.datetime.today()
    pdf.close()

def T9():
    import bone
    reload(bone)
    import datetime
    from matplotlib.backends.backend_pdf import PdfPages
    pdf = PdfPages('figures/rb-surv-1.pdf')
    from matplotlib import pyplot as plt
    fig, ax = plt.subplots(nrows=1, ncols=2, figsize=(10,5))
    low = set(bone.getEntries("figures/r-s-c-down.txt", 0))
    high = set(bone.getEntries("figures/r-s-c-up.txt", 0))
    l1 = [ high, low]
    wt1 = [-1, 1]
    ana = bone.RBAnalysis()
    ana.getBos()
    ana.orderData(l1, wt1)
    thr = hu.getThrData(ana.f_ranks)
    nm = (np.max(ana.f_ranks) - np.min(ana.f_ranks))/16
    fthr = thr[0] + 1.5 * nm
    fthr = thr[0] - 1.5 * nm
    print(thr)
    print(nm, fthr)
    ESR1 = "ESR1"
    id1 = ESR1
    low = ana.h.getArraysAll(id1, "thr0", "lo")
    high = ana.h.getArraysAll(id1, "thr0", "hi")
    g1 = [i for i in low if
            ana.f_ranks[i - ana.h.start] < fthr]
    g2 = [i for i in low if
            ana.f_ranks[i - ana.h.start] >= fthr]
    pG = [ ["Low", "green", g1], ["High", "red", g2]]
    time = ana.h.getSurvName('time')
    status = ana.h.getSurvName('status')
    time, status = hu.censor(time, status, 120)
    sax = hu.survival(time, status, pG, ax[0])
    sax.set_title(ana.h.getTitle())
    g1 = [i for i in high if
            ana.f_ranks[i - ana.h.start] < fthr]
    g2 = [i for i in high if
            ana.f_ranks[i - ana.h.start] >= fthr]
    pG = [ ["Low", "green", g1], ["High", "red", g2]]
    time = ana.h.getSurvName('time')
    status = ana.h.getSurvName('status')
    time, status = hu.censor(time, status, 120)
    sax = hu.survival(time, status, pG, ax[1])
    sax.set_title(ana.h.getTitle())
    pdf.savefig(fig)

    fig, ax = plt.subplots(nrows=1, ncols=2, figsize=(10,5))
    low = set(bone.getEntries("figures/r-s-c-down.txt", 0))
    high = set(bone.getEntries("figures/r-s-c-up.txt", 0))
    l1 = [ high, low]
    wt1 = [-1, 1]
    ana = bone.RBAnalysis()
    ana.getSurvival("BC36")
    ana.orderData(l1, wt1)
    thr = hu.getThrData(ana.f_ranks)
    nm = (np.max(ana.f_ranks) - np.min(ana.f_ranks))/16
    fthr = thr[0] + 1.5 * nm
    fthr = thr[0] - 0.5 * nm
    print(thr)
    print(nm, fthr)
    ESR1 = "ESR1"
    id1 = ESR1
    low = ana.h.getArraysAll(id1, "thr0", "lo")
    high = ana.h.getArraysAll(id1, "thr0", "hi")
    g1 = [i for i in low if
            ana.f_ranks[i - ana.h.start] < fthr]
    g2 = [i for i in low if
            ana.f_ranks[i - ana.h.start] >= fthr]
    pG = [ ["Low", "green", g1], ["High", "red", g2]]
    time = ana.h.getSurvName('time')
    status = ana.h.getSurvName('status')
    time, status = hu.censor(time, status, 120)
    sax = hu.survival(time, status, pG, ax[0])
    sax.set_title(ana.h.getTitle())
    g1 = [i for i in high if
            ana.f_ranks[i - ana.h.start] < fthr]
    g2 = [i for i in high if
            ana.f_ranks[i - ana.h.start] >= fthr]
    pG = [ ["Low", "green", g1], ["High", "red", g2]]
    time = ana.h.getSurvName('time')
    status = ana.h.getSurvName('status')
    time, status = hu.censor(time, status, 120)
    sax = hu.survival(time, status, pG, ax[1])
    sax.set_title(ana.h.getTitle())
    pdf.savefig(fig)

    fig, axes = plt.subplots(nrows=1, ncols=2, figsize=(10,5))
    low = set(bone.getEntries("figures/r-s-c-down.txt", 0))
    high = set(bone.getEntries("figures/r-s-c-up.txt", 0))
    l1 = [ high, low]
    wt1 = [-1, 1]
    ana = bone.RBAnalysis()
    ana.getSurvival("P7")
    ana.orderData(l1, wt1)
    sax, ax = ana.printSurvival("thr0", None, None, None, axes[0])
    sax.set_title(ana.h.getTitle())

    low = set(bone.getEntries("figures/r-s-c-down.txt", 0))
    high = set(bone.getEntries("figures/r-s-c-up.txt", 0))
    l1 = [ high, low]
    wt1 = [-1, 1]
    ana = bone.RBAnalysis()
    ana.getSurvival("P9")
    ana.orderData(l1, wt1)
    sax, ax = ana.printSurvival(-75, None, None, 60, axes[1])
    sax.set_title(ana.h.getTitle())
    pdf.savefig(fig)


    fig, axes = plt.subplots(nrows=1, ncols=2, figsize=(10,5))
    low = set(bone.getEntries("figures/r-s-c-down.txt", 0))
    high = set(bone.getEntries("figures/r-s-c-up.txt", 0))
    l1 = [ high, low]
    wt1 = [-1, 1]
    ana = bone.RBAnalysis()
    ana.getSurvival("PANC2")
    ana.orderData(l1, wt1)
    sax, ax = ana.printSurvival(-15, None, None, None, axes[0])
    sax.set_title(ana.h.getTitle())


    low = set(bone.getEntries("figures/r-s-c-down.txt", 0))
    high = set(bone.getEntries("figures/r-s-c-up.txt", 0))
    l1 = [ high, low]
    wt1 = [-1, 1]
    ana = bone.RBAnalysis()
    ana.getJSTOM()
    ana.orderData(l1, wt1)
    sax, ax = ana.printSurvival("thr0", None, None, None, axes[1])
    sax.set_title(ana.h.getTitle())
    pdf.savefig(fig)

    fig, axes = plt.subplots(nrows=1, ncols=2, figsize=(10,5))
    low = set(bone.getEntries("figures/r-s-c-down.txt", 0))
    high = set(bone.getEntries("figures/r-s-c-up.txt", 0))
    l1 = [ high, low]
    wt1 = [-1, 1]
    ana = bone.RBAnalysis()
    ana.getSurvival("LU7")
    ana.orderData(l1, wt1)
    sax, ax = ana.printSurvival("thr2", None, None, None, axes[0])
    sax.set_title(ana.h.getTitle())


    low = set(bone.getEntries("figures/r-s-c-down.txt", 0))
    high = set(bone.getEntries("figures/r-s-c-up.txt", 0))
    l1 = [ high, low]
    wt1 = [-1, 1]
    ana = bone.RBAnalysis()
    ana.getSurvival("LU6.2")
    ana.orderData(l1, wt1)
    sax, ax = ana.printSurvival("thr2", None, None, None, axes[1])
    sax.set_title(ana.h.getTitle())
    pdf.savefig(fig)

    d = pdf.infodict()
    d['Title'] = 'Prediction diffferentiation state'
    d['Author'] = 'Debashis Sahoo'
    d['Subject'] = 'Retina retinoblastoma'
    d['Keywords'] = 'disease training validation ROC retina'
    d['CreationDate'] = datetime.datetime(2020, 1, 16)
    d['ModDate'] = datetime.datetime.today()
    pdf.close()

def T10():
    from matplotlib.backends.backend_pdf import PdfPages
    pdf = PdfPages('figures/rb-surv-2.pdf')
    import bone
    reload(bone)
    import datetime
    from matplotlib import pyplot as plt
    ana = bone.RBAnalysis()
    ana.getSurvival("BC36")
    #ana.getBos()

    time = ana.h.getSurvName('time')
    status = ana.h.getSurvName('status')
    df = pd.DataFrame()
    sorder = ana.h.aRange()
    df['time'] = [time[i] for i in sorder]
    df['status'] = [status[i] for i in sorder]
    ESR1 = "ESR1"
    id1 = ESR1
    expr = ana.h.getExprData(id1)
    thr = ana.h.getThrData(id1)
    fthr = thr[0]
    df['ESR1'] = [2 if float(expr[i]) < fthr else 1 for i in sorder]
    atype = ana.h.getSurvName('c er_status')
    ahash = {'pos':0, 'neg':1}
    aval = [ahash[k] if k in ahash else np.NaN for k in atype]
    df['ER'] = [aval[i] for i in sorder]

    low = set(bone.getEntries("figures/r-s-c-down.txt", 0))
    high = set(bone.getEntries("figures/r-s-c-up.txt", 0))
    l1 = [ high, low]
    wt1 = [-1, 1]
    ana.orderData(l1, wt1)
    thr = hu.getThrData(ana.f_ranks)
    nm = (np.max(ana.f_ranks) - np.min(ana.f_ranks))/16
    fthr = thr[0] - 0.5 * nm
    #fthr = thr[0] - 1.5 * nm
    df['iDEGs'] = [2 if ana.f_ranks[i - ana.h.start] < fthr else 1 for i in sorder]

    l2 = bone.readList("figures/ravi-down.txt")
    l3 = bone.readList("figures/sailaja-down.txt")
    low = set(l2).intersection(l3)
    l4 = bone.readList("figures/ravi-up.txt")
    l5 = bone.readList("figures/sailaja-up.txt")
    high = set(l4).intersection(l5)
    l1 = [l4, l2]
    wt1 = [-1, 1]
    ana.orderData(l1, wt1)
    thr = hu.getThrData(ana.f_ranks)
    nm = (np.max(ana.f_ranks) - np.min(ana.f_ranks))/16
    fthr = thr[0] - 0.5 * nm
    #fthr = thr[0] - 1.5 * nm
    df['DEGs1'] = [2 if ana.f_ranks[i - ana.h.start] < fthr else 1 for i in sorder]
    l1 = [l5, l3]
    ana.orderData(l1, wt1)
    thr = hu.getThrData(ana.f_ranks)
    nm = (np.max(ana.f_ranks) - np.min(ana.f_ranks))/16
    fthr = thr[0] - 0.5 * nm
    #fthr = thr[0] - 1.5 * nm
    df['DEGs2'] = [2 if ana.f_ranks[i - ana.h.start] < fthr else 1 for i in sorder]
    l1 = [high, low]
    ana.orderData(l1, wt1)
    thr = hu.getThrData(ana.f_ranks)
    nm = (np.max(ana.f_ranks) - np.min(ana.f_ranks))/16
    fthr = thr[0] - 0.5 * nm
    #fthr = thr[0] - 1.5 * nm
    df['DEGs'] = [2 if ana.f_ranks[i - ana.h.start] < fthr else 1 for i in sorder]

    df1 = df.copy()
    df1 = df1.drop(columns=['ESR1', 'DEGs'])
    df1 = df1.replace('', np.NaN)
    df1.dropna(inplace=True)
    #df1 = df1[(df1['time'] != '') & (df1['status'] != '')]
    dfu, dfm = hu.Multivariate(df1)
    ax = hu.plotCoef(dfu)
    ax.set_xscale('log')
    pdf.savefig()
    ax = hu.plotCoef(dfm)
    ax.set_xscale('log')
    pdf.savefig()
    hu.printCoef(dfu)
    hu.printCoef(dfm)


    d = pdf.infodict()
    d['Title'] = 'Prediction diffferentiation state'
    d['Author'] = 'Debashis Sahoo'
    d['Subject'] = 'Retina retinoblastoma'
    d['Keywords'] = 'disease training validation ROC retina'
    d['CreationDate'] = datetime.datetime(2020, 1, 16)
    d['ModDate'] = datetime.datetime.today()
    pdf.close()


#T1()
#T2()
#T3()
#T4()
#T5()
#T6()
#T7()
#T8()
#T9()
T10()
